/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"

int main(void)
{
    //CyGlobalIntEnable; /* Enable global interrupts. */

    LED_Write(0);
    //while(PSB_Read());
    
    //PWM_DAC_Start();
    //PWM_DAC_WriteCompare(15);
    ClearOutput_Write(1);
    PWM_Counter_Start();
    //PWM_Counter_Init();
    UART_Start();
    //LCD1602_Start();
    //LCD1602_Position(0,0);
    //LCD1602_PrintString("Test");
    //LCD1602_Position(1,0);
    //LCD1602_PrintString("Test");
    //LCD1602_PutChar(0x08);
    //LCD1602_PutChar(0x01);
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */

    unsigned char comData[11];
    char inChar;
    unsigned char i=0, j=0; //, cmdCount=0;
    unsigned int period=0, onTime=0;

    //LED_Write(1);
    while(1)
    {
        while(UART_ReadRxStatus()==UART_RX_STS_FIFO_NOTEMPTY){
            inChar=UART_GetChar();
            
            if(inChar=='$')
                i = 0;
            else{
                if(i>=10)
                    break;
                else
                    i++;
            }
            comData[i]=inChar;
        }
        
        if(comData[10]=='#'){
            if(comData[0]=='$' && comData[5]=='&'){
                period=0;
                onTime=0;
                period |=comData[1];
                period <<=8;
                period |=comData[2];
                period <<=8;
                period |=comData[3];
                period <<=8;
                period |=comData[4];
                
                onTime |= comData[6];
                onTime<<=8;
                onTime |= comData[7];
                onTime<<=8;
                onTime |= comData[8];
                onTime<<=8;
                onTime |= comData[9];

                //this is in case the output is enabled when changing config
                PWM_Counter_WritePeriod(period);
                PWM_Counter_WriteCompare(onTime);
                PWM_Counter_WriteCounter(0);
                //counterClear_Write(1);
                //cmdCount++;
                /*
                LCD1602_ClearDisplay();
                LCD1602_Position(0,0);
                LCD1602_PrintString("Current Config:");
                LCD1602_Position(1,0);
                LCD1602_PrintString("T:");
                LCD1602_PrintU32Number(period);
                LCD1602_Position(2,0);
                LCD1602_PrintString("A:");
                LCD1602_PrintU32Number(onTime);
                
                LCD1602_Position(3,0);
                LCD1602_PrintString("CMD:");
                LCD1602_PrintU32Number((unsigned int)cmdCount);
                */
                for(j=0;j<11;j++){
                    comData[j]=0;
                }
                
                UART_ClearRxBuffer();
            }
            else if(comData[0]=='$' && comData[5]=='E'){
                PWM_Counter_Enable();
                //PWM_Counter_WritePeriod(period);
                //PWM_Counter_WriteCompare(onTime);
                LED_Write(1);
                PWM_Counter_WriteCounter(0);
                //counterClear_Write(1);
                for(j=0;j<11;j++){
                    comData[j]=0;
                }
                ClearOutput_Write(1);
            }
            else if(comData[0]=='$' && comData[5]=='D'){
                PWM_Counter_Stop();
                //counterClear_Write(1);
                PWM_Counter_WriteCounter(0);
                LED_Write(0);
                for(j=0;j<11;j++){
                    comData[j]=0;
                }
                ClearOutput_Write(0);
            }
        }
    }
}

/* [] END OF FILE */
